using System;
using System.Runtime.InteropServices;
using System.Windows;

namespace FinalDemo.Assets.Win32
{
	public static class Win32Api
	{
		[DllImport("User32")]
		internal static extern IntPtr MonitorFromWindow(IntPtr handle, int flags);

		[DllImport("user32")]
		internal static extern bool GetMonitorInfo(IntPtr hMonitor, MONITORINFO lpmi);

		public static void WmGetMinMaxInfo(IntPtr hwnd, IntPtr lParam)
		{
			MINMAXINFO structure = (MINMAXINFO)Marshal.PtrToStructure(lParam, typeof(MINMAXINFO));
			IntPtr hMonitor = MonitorFromWindow(hwnd, 2);
			if (hMonitor != IntPtr.Zero)
			{
				MONITORINFO lpmi = new MONITORINFO();
				GetMonitorInfo(hMonitor, lpmi);
				RECT rcWork = lpmi.rcWork;
				RECT rcMonitor = lpmi.rcMonitor;
				structure.ptMaxPosition.x = Math.Abs((int)(rcWork.left - rcMonitor.left));
				structure.ptMaxPosition.y = Math.Abs((int)(rcWork.top - rcMonitor.top));
				structure.ptMaxSize.x = Math.Abs((int)(rcWork.right - rcWork.left));
				structure.ptMaxSize.y = Math.Abs((int)(rcWork.bottom - rcWork.top));
				structure.ptMinTrackSize.x = (int)Application.Current.MainWindow.MinWidth;
				structure.ptMinTrackSize.y = (int)Application.Current.MainWindow.MinHeight;
			}
			Marshal.StructureToPtr(structure, lParam, true);
		}
		
	}
}