using System;
using FinalDemo.Framework;

namespace FinalDemo.ViewModel
{
	public class TaskViewModel : ViewModelBase, IViewAware
	{
		public string TaskName { get; set; }

		private DelegateCommand _closeCommand;
		public DelegateCommand CloseCommand
		{
			get { return _closeCommand ?? (_closeCommand = new DelegateCommand(FireCloseRequest)); }
		}

		private void FireCloseRequest()
		{
			var handler = CloseDialogView;
			if (handler != null)
				handler(true);
		}

		#region Implementation of IViewAware

		public void ViewActivated()
		{
			
		}

		public void ViewDeactivated()
		{
			
		}

		public event Action CloseView;
		public event Action<bool> CloseDialogView;

		#endregion
	}
}